
!Object methodsFor: '*LazyRabbit' stamp: 'hjo 1/30/2009 17:42'!
setDefault: defaultSymbol for: anObject withSetter: setter

	"I am not nil, so do nothing."! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'hjo 1/30/2009 17:42'!
setDefault: defaultSymbol for: anObject withSetter: setter

	anObject perform: setter with: (anObject perform: defaultSymbol)! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/4/2009 15:13'!
addLazyInstVarName: newInstVarName

	self addInstVarName: newInstVarName.
	self createLazyInstVarAccessors: newInstVarName! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 14:43'!
addLazyInstVarNameWithDefault: variableName 

	self addInstVarName: variableName.
	self createLazyInstVarAccessorsWithDefault: variableName! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/4/2009 15:08'!
createLazyInstVarAccessors

	self instVarNames do: [:v| self createLazyInstVarAccessors: v ].! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 12:44'!
createLazyInstVarAccessors: variableName

	self createLazyInstVarSetter: variableName.
	self createLazyInstVarDefault: variableName.
	self createLazyInstVarGetter: variableName.! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 15:54'!
createLazyInstVarAccessorsWithDefault: variableName

	| defaultCode |
	defaultCode := FillInTheBlank
			request: 'Default Generator code'
			initialAnswer:  '^0'
			centerAt: Sensor cursorPoint.
	defaultCode isEmpty ifTrue: [ defaultCode := 'self shouldBeImplemented' ].
	self createLazyInstVarSetter: variableName.
	self createLazyInstVarDefault: variableName withSource: defaultCode.
	self createLazyInstVarGetter: variableName.! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 15:55'!
createLazyInstVarDefault: variableName.

	self createLazyInstVarDefault: variableName withSource: 'self shouldBeImplemented' 
! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 13:00'!
createLazyInstVarDefault: variableName withSource: aByteString 

	(self canUnderstand: ('default', variableName capitalized) asSymbol)
		ifFalse: [ self compile: ('default', variableName capitalized , '

	"Return a default object for instance variable ',variableName,'."
	', aByteString)
		classified: 'defaults' notifying: nil].
! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 12:44'!
createLazyInstVarGetter: variableName

	(self canUnderstand: variableName asSymbol)
	ifFalse: [ self compile: (variableName ,
'

	',variableName,' setDefault: #default', variableName capitalized ,' for: self withSetter: #',variableName,': .
	^',
variableName)
		classified: 'accessing' notifying: nil].
! !

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 3/24/2009 12:58'!
createLazyInstVarSetter: variableName

	(self canUnderstand: (variableName,':') asSymbol)
		ifFalse: [ self compile: (variableName ,': anObject
		
	',variableName,' := anObject')
		classified: 'accessing' notifying: nil].! !
